> For the complete documentation index, see [llms.txt](https://docs.essencefinance.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.essencefinance.io/development/smart-contracts/timelocks/itimelockeddelegator.md).

# ITimelockedDelegator

## IZen

### Functions

#### delegate

```solidity
function delegate(
    address delegatee
) external
```

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `delegatee` | address |             |

## ITimelockedDelegator

### Functions

#### delegate

```solidity
function delegate(
    address delegatee,
    uint256 amount
) external
```

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `delegatee` | address |             |
| `amount`    | uint256 |             |

#### undelegate

```solidity
function undelegate(
    address delegatee
) external returns (uint256)
```

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `delegatee` | address |             |

#### delegateContract

```solidity
function delegateContract(
    address delegatee
) external returns (address)
```

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `delegatee` | address |             |

#### delegateAmount

```solidity
function delegateAmount(
    address delegatee
) external returns (uint256)
```

**Parameters**

| Name        | Type    | Description |
| ----------- | ------- | ----------- |
| `delegatee` | address |             |

#### totalDelegated

```solidity
function totalDelegated() external returns (uint256)
```

#### zen

```solidity
function zen() external returns (contract IZen)
```

### Events

#### Delegate

```solidity
event Delegate(
    address _delegatee,
    uint256 _amount
)
```

**Parameters**

| Name           | Type    | Description |
| -------------- | ------- | ----------- |
| `_delegatee`   | address |             |
| `_amount`      | uint256 |             |
| ### Undelegate |         |             |

```solidity
event Undelegate(
    address _delegatee,
    uint256 _amount
)
```

**Parameters**

| Name         | Type    | Description |
| ------------ | ------- | ----------- |
| `_delegatee` | address |             |
| `_amount`    | uint256 |             |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.essencefinance.io/development/smart-contracts/timelocks/itimelockeddelegator.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
